unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.StdCtrls, Vcl.Buttons,
  Vcl.ExtCtrls, VclTee.TeeGDIPlus, VCLTee.Series, VCLTee.TeEngine,
  VCLTee.TeeProcs, VCLTee.Chart, system.UITypes;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series3: TPointSeries;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function Gamma(x: Extended): Extended;  // K}֐
const
//xk[CB(2)AB(4)AB(6)A...AB(16)
  B : array[1..8] of Extended = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510);     // B(16)

  m: integer = sizeof(B) div sizeof(Extended);
var
  i : integer;
  sum : Extended;
  xx, v  : Extended;
  xj  : Extended;
  lng : Extended;
  ln_sqrt_2pi: Extended;
begin
  ln_sqrt_2pi := ln(sqrt(2 * pi));                    // = ln(2 * pi) / 2;
  sum := 0;
  v := 1;
	while x < m do begin
    v := v * x;
    x := x + 1;
  end;
  xx := x * x;
  xj := x;
  lng := ln_sqrt_2pi - x + (x - 0.5) * ln(x) - ln(v);
  for i := 1 to  m do begin
    sum := sum + B[i] / (i * 2 * (2 * i - 1)) / xj;
    xj := xj * xx;
  end;
  result := exp(sum + lng);
end;

// ========================================================================
// x  -5@菬Ȃƌ덷傫Ȃ܂
//=========================================================================
function Riemann_Zeta_Function(x: extended): extended;
const
  N = 8;
  coef: array[0..19] of extended = (
	 8.333333333333333333333333333e-2,  //  1/12
	-1.388888888888888888888888889e-3,  // -1/720
	 3.306878306878306878306878307e-5,  //  1/30240
	-8.267195767195767195767195767e-7,  // -1/1209600
	 2.087675698786809897921009032e-8,  //  1/47900160
	-5.284190138687493184847682202e-10,
	 1.338253653068467883282698098e-11,
	-3.389680296322582866830195391e-13,
	 8.586062056277844564135905450e-15,
	-2.174868698558061873041516424e-16,
	 5.509002828360229515202652609e-18,
	-1.395446468581252334070768626e-19,
	 3.534707039629467471693229977e-21,
	-8.953517427037546850402611251e-23,
	 2.267952452337683060310950058e-24,
	-5.744790668872202445263829503e-26,
	 1.455172475614864901866244572e-27,
	-3.685994940665310178130050728e-29,
	 9.336734257095044668660153106e-31,
	-2.365022415700629886484029550e-32
  );

var
	i, N2 : integer;
	powNx, w, z, zprev: extended;
begin
  if x = 1 then begin
    result := infinity;
    exit;
  end;
	z := 1;
	for i := 2 to N - 1 do begin
		zprev := z;
		z := z + power(i, -x);
		if z = zprev then begin
      result :=  z;
      exit;
    end;
	end;
  N2 := N * N;
	powNx := power(N, x);
  w := x / (N * powNx);
	z := z + 0.5 / powNx + N / ((x - 1) * powNx) + coef[0] * w;
  i := 1;
	while  (i < 20) and (z <> zprev) do begin
		w := w * (x + 2 * i - 1) * (x + 2 * i) / (N2);
		zprev := z;
		z := z + coef[i] * w;
    inc(i);
	end;
	result := z;
end;

function RiemannFunction(s: Extended): Extended;
var
  term : Extended;
  ints : integer;
  def : Extended;
begin
  ints := trunc(s);
  def := s - ints;
  if (s <= -2) and (def = 0) and (ints mod 2 = 0) then
    result := 0
  else
  if s < -1 then begin                           // -s 덷傫Ȃ̂ŃĂ+ŌvZ܂
    term := power(2, s) * power(pi, s - 1) * sin(pi * s / 2);
    result := term * Riemann_Zeta_Function(1 - s) * Gamma(1 - s);
  end
  else
    result := Riemann_Zeta_Function(s);
end;

function Dirichlet_Lambda_Function(x: extended): extended;
begin
  result := (1 - power(2, -x)) * RiemannFunction(x);
//  result := power(2, -x) * (power(2, x) - 1) * Riemann_Zeta_Function(x);
end;

//------------------------------------------------------------------------------
// vZ̎sƃOt쐬
//------------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  n = 2000;
var
  Lambda, Lambdab: extended;
  star: extended;
  s : extended;
  i : integer;
  min, max, dx: extended;
begin
  val(LabeledEdit1.Text, s, i);
  if i <> 0 then begin
    MessageDlg('x̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  Lambda := Dirichlet_Lambda_Function(s);
  star := Lambda - 1;
  Memo1.Clear;
  Memo1.Lines.Add('Ɋ֐');
  Memo1.Lines.Add('(s)      = ' + floatTostr(Lambda));
  Memo1.Lines.Text := Memo1.Lines.Text + '(s) - 1 = ' + floatTostr(star);
  Series1.Clear;
  Series3.Clear;
  if Lambda > 3 then Lambda := 3;
  if Lambda < -2 then Lambda := -2;
  Series3.AddXY(s, Lambda);
  min :=  -10;
  if s < min then min := s;
  max :=  5;
  if s > max then max := s;
  dx := (max - min) / n;
  Lambdab := 1;
  for i := 0 to n do begin
    s := i * dx + min;
    Lambda := Dirichlet_Lambda_Function(s);
    if Lambda > 3 then Lambda := 3;
    if (Lambdab = -2) and (Lambda = 3) then begin
      Series1.AddXY(s, Lambdab, '', clBlue);
      Series1.AddXY(s, Lambda, '', clBlue);
    end;
    if Lambda < -2 then Lambda := -2;
    if (Lambda < 3) and (Lambda > -2) then Series1.AddXY(s, Lambda, '', clBlue)
                                // Ot̃x[X̐FƓɂČȂ܂B
                                else Series1.AddXY(s, Lambda, '', clBtnFace);
    Lambdab := Lambda;
  end;
end;

end.
