unit Gamma_Function;

interface
  function xGamma_Function(x: extended): extended;

implementation

uses system.math;

const
  LONG_MAX = 2147483647;
  max_long_double_arg: extended = 1755.5;
  g =  9.65657815377331589457187;
  e =  2.71828182845904523536028747;
  exp_g_o_sqrt_2pi = 6.23316569877722552586386e+3;
  a: array[0..8] of extended = (
                                +1.14400529453851095667309e+4,
                                -3.23988020152318335053598e+4,
                                +3.50514523505571666566083e+4,
                                -1.81641309541260702610647e+4,
                                +4.63232990536666818409138e+3,
                                -5.36976777703356780555748e+2,
                                +2.28754473395181007645155e+1,
                                -2.17925748738865115560082e-1,
                                +1.08314836272589368860689e-4
                               );

function xGamma(x: extended): extended; forward;

//=============================================================================
//
// ̊֐Lanczos̎gpĎۂGamma(x)vZ܂B
// x͈̔͂ -(max_long_double_arg-1) < x < max_long_double_argB
// K}֐͕fʂŗL^łAłȂ̒l
// xa̐̐܂͔̐̐eXgƁA
// őΑΌ덷͖3.5e-16łB
//
// x > max_long_double_arg̏ꍇAlnGamma(x)gpKv܂B
// x < 0 ̏ꍇAln(Gamma(x)) ͕fɂȂ\邱ƂɒӂĂB
//
// ߂l
//  xŁAmax_long_double_arg菬ꍇAGamma(x)
//  ԂAx > max_long_double_arg̏ꍇAmaxextendedԂ܂B
//  xłȂ̏ꍇAmaxextended
//  Ԃ܂iGamma(x)͒l̗ŕύX邱ƂɒӂĂjB
//  x񐳂̔񐮐̏ꍇx>-(max_long_double_arg + 1j̏ꍇ
//  Gamma(x)Ԃ܂BȊȌꍇ0.0Ԃ܂
//
//=============================================================================
function xGamma_Function(x: extended): extended;
var
  sin_x: extended;
  rg: extended;
  ix: int64;
begin
  if x > 0 then
    if x <= max_long_double_arg then begin
      result := xGamma(x);
      exit;
    end
    else begin
      result := maxextended;
      exit;
    end;
  if x > -LONG_MAX then begin
    ix := round(x);
    if x = ix then begin
      result := maxextended;
      exit;
    end;
  end;
  sin_x := sin(pi * x);
  if sin_x = 0 then begin
    result := maxextended;
    exit;
  end;
  if x < - max_long_double_arg - 1 then begin
    result := 0;
    exit;
  end;
  rg := xGamma(1 - x) * sin_x / pi;
  if rg <> 0 then result := 1 / rg
             else result := maxextended;
end;

//=============================================================================
//
// ̊֐͔{gpGamma(two_x)Ԃ܂B
//
//=============================================================================
function Duplication_Formula(two_x: extended): extended;
var
  x: extended;
  g: extended;
  n: integer;
begin
  x := 0.5 * two_x;
  n := round(two_x) - 1;
  g := power(2.0, two_x - 1.0 - n);
  g := g * power(2, n);
  g := g / sqrt(pi);
  g := g * xGamma_Function(x);
  g := g * xGamma_Function(x + 0.5);
  result := g;
end;

//=============================================================================
//
// ̊֐Lanczos̎gpĎۂGamma(x)vZ܂B
// xA0<x<=900B900<x<1755.5̏ꍇA{gp܂B
// ֐power()Bʂ̑Ό덷͖10^-16łBx = 0t߂܂B
// x>1755.5̏ꍇAlnGamma(x)vZKv܂B
// x1755.5̏ꍇAGamma(x)ԂA
// x>1755.5̏ꍇAmaxextendedԂ܂B
//
//=============================================================================
function xGamma(x: extended): extended;
var
  xx: extended;
  temp: extended;
  n, i: integer;
  xx2 : extended;
begin
  if x < 1 then xx := x + 1 else xx := x;
  n := sizeof(a) div sizeof(extended);
  if x > max_long_double_arg then begin
    result := maxextended;
    exit;
  end;
  if x > 900 then begin
    result := Duplication_Formula(x);
    exit;
  end;
  temp := 0;
  for i := n - 1 downto 0 do temp := temp + a[i] / (xx + i);
  temp := temp + 1;
  xx2 := (xx - 0.5) / 2;
  temp := temp * (power((g + xx - 0.5) / e, xx2) / exp_g_o_sqrt_2pi );
  temp := temp * power((g + xx - 0.5) / e, xx2);      // X64 I[o[t[΍
  if x < 1 then result := temp / x
           else result := temp;
end;

end.
