unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.StdCtrls, Vcl.Buttons,
  Vcl.ExtCtrls, VclTee.TeeGDIPlus, VCLTee.Series, VCLTee.TeEngine,
  VCLTee.TeeProcs, VCLTee.Chart, system.UITypes;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series3: TPointSeries;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

  LDBL_EPSILON : extended;

implementation

{$R *.dfm}

uses dirichlet_eta, Riemann_Zeta;

//==================================================================================================
// function Lambda_Star_Negative_Argis: extended): extended
//
// ̃[`́As <0@̃fBN_X^[֐vZ܂B
//
// lambda *(s)=[(2^s -1)/i2^s] zeta*(s)- 1/2^sA
//    zeta*(s) zeta*֐łB
//
//==================================================================================================
function Lambda_Star_Negative_Arg(s: extended): extended;
var
  zeta_star: extended;
  lambda_star: extended;
  two_minus_s: extended;
  two_minus_s1: extended;
begin
  zeta_star := xRiemann_Zeta_Star_Function(s);
  if abs(zeta_star) = MAXExtended then begin
    result := -zeta_star;
    exit;
  end;
  two_minus_s := power(2.0, -s);
  two_minus_s1 := two_minus_s - 1.0;
  if two_minus_s1 < 1 then
    two_minus_s1 := 1;  // two_minus_s11Ɛ鎞1̔ŏIrbgɌ덷o܂
  if abs(zeta_star) > MAXExtended / two_minus_s1 then begin
    if zeta_star < 0.0 then  result :=  MAXExtended else result := -MAXExtended;
    exit;
  end;
  lambda_star := (1.0 - two_minus_s) * zeta_star;
  if lambda_star > 0.0 then begin
    result :=  lambda_star - two_minus_s;
    exit;
  end;
  if lambda_star < two_minus_s - MAXExtended then begin
    result := -MAXExtended;
    exit;
  end;
  result :=  lambda_star - two_minus_s;
end;

//==================================================================================================
// function Lambda_Star_Positive_Arg(s: extended): extended;
//  ̃[`́As >= 0 ̃fBN_X^[֐vZ܂B
//==================================================================================================
function Lambda_Star_Positive_Arg(s: extended): extended;
const
  LDBL_MAX_EXP = 16384;       // 64rbg(double)̎1024
var
  zeta_star: extended;
  two_s: extended;
begin
  if s = 1.0 then begin
    result :=  MAXExtended;
    exit;
  end;
  zeta_star := xRiemann_Zeta_Star_Function(s);
  if s > LDBL_MAX_EXP then begin
    result := zeta_star;
    exit;
  end;
  two_s := power(2.0, s);
  result := ((two_s - 1.0) * zeta_star - 1.0) / two_s;
end;

//==================================================================================================
// function xDirichlet_Lambda_Star_Function(s: extended): extended;
//
// ̃[`́Â悤ɒ`ꂽfBN_X^[֐vZ܂B
//   *(s) = -1A
//  lambda()̓fBN_֐łB
//
// lambda*(s)= [zeta*(sj+ eta*(s)] / 2 ł邱ƂɒӂĂB
//    zeta*̓[}[[^X^[֐Ɓ@eta*̓fBÑC[^X^[֐łB
// s̒lɂČvZI܂B
//==================================================================================================
function xDirichlet_Lambda_Star_Function(s: extended): extended;
begin
  if s = 0.0 then  begin
    result :=  -1.0;
    exit;
  end;
  if s > 0.0 then
    result :=  Lambda_Star_Positive_Arg(s)
  else
    result := Lambda_Star_Negative_Arg(s);
end;

//==================================================================================================
// function Dirichlet_Lambda_Star_Function(s: double): edouble;
//
// ̃[`́Â悤ɒ`ꂽfBN_X^[֐vZ܂B
//   *(s) = -1A
//  lambda()̓fBN_֐łB
//
// lambda*(s)= [zeta*(sj+ eta*(s)] / 2 ł邱ƂɒӂĂB
//  zeta*̓[}[[^X^[֐Ɓ@eta*̓fBÑC[^X^[֐łB
//==================================================================================================
function Dirichlet_Lambda_Star_Function(s: double): double;
var
  lambda_star: extended;
begin
  if s = 1 then begin
    result :=  MAXDouble;
    exit;
  end;
  lambda_star := xDirichlet_Lambda_Star_Function(s);
  if abs(lambda_star) >= MAXDouble then begin
    if lambda_star < 0.0 then  result := -MAXDouble else result := MAXDouble;
    exit;
  end;
  result := lambda_star;
end;

//==================================================================================================
// function xDirichlet_Lambda_Function(s: extended): extended;
//
// fBN_֐͎̂悤ɒ`܂
//   lambda(s)= Sum(1 /(2k + 1)^sjA k = 0A...ōv܂B
//	sRe(s)> 1̕fłB
// ɁA͓Iɕfʂ̎c̕ɐi݂܂B
// s = 1̏ꍇALDBL_MAXԂ܂B//
// lambdaisj> LDBL_MAX̏ꍇALDBL_MAXԂA
// lambdaisj<-LDBL_MAX̏ꍇA-LDBL_MAXԂ܂B
// lim lambda(s)= -infAs-> 1Alim lambda(s)= inf Es-> 1B
//
// lambda(s)= [zeta(s)+ eta(s)] / 2ł邱ƂɒӂĂB
//   ŁAzeta̓[}[[^֐eta̓fBÑC[^֐łB
//
// lambda(s)= 1 + lambda_star(s)
//==================================================================================================
function xDirichlet_Lambda_Function(s : extended): extended;
var
  lambda_star: extended;
begin
  if s = 1 then begin
    result := MAXExtended;
    exit;
  end;
  lambda_star := xDirichlet_Lambda_Star_Function(s);
  if abs(lambda_star) = MAXExtended then begin
    result := lambda_star;
    exit;
  end;
  result :=  1.0 + lambda_star;
end;

//==================================================================================================
// function Dirichlet_Lambda_Star_Function(s: double): double;
//
// ̃[`́Â悤ɒ`ꂽfBN_X^[֐vZ܂B
//  *(s) = (s)-1A
//     lambda()̓fBN_֐łB//
//
// lambda*(s)= [zeta*(s)+ eta*(s)] / 2 ł邱ƂɒӂĂB
//    zeta* [}[[^*֐eta* fBÑC[^X^[֐łB
//==================================================================================================
function Dirichlet_Lambda_Function(s : double): double;
var
  lambda: extended;
begin
  if s= 1.0 then begin
    result := MAXDouble;
    exit;
  end;
  lambda := xDirichlet_Lambda_Function(s);
  if abs(lambda) >= MAXDouble then  begin
    if lambda < 0.0 then  result := -MAXDouble else result := MaxDouble;
    exit;
  end;
  result := lambda;
end;

//--------------------------------------------------------------------------------------------------
// vZ̎sƃOt쐬
//--------------------------------------------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  n = 2000;
var
  Lambda, Lambdab: double;
  star: double;
  s : double;
  i : integer;
  min, max, dx: double;
begin
  val(LabeledEdit1.Text, s, i);
  if i <> 0 then begin
    MessageDlg('x̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  Lambda := Dirichlet_Lambda_Function(s);
  star := Dirichlet_Lambda_Star_Function(s);
  Memo1.Clear;
  Memo1.Lines.Add('Ɋ֐');
  // s = 1̎MaxDoubleɂȂ̂Ł\
  if s <> 1 then begin
    Memo1.Lines.Add('(x)      = ' + floatTostr(Lambda));
    Memo1.Lines.Text := Memo1.Lines.Text + '(x) - 1 = ' + floatTostr(star);
//  Memo1.Lines.Add('(x) - 1 = ' + floatTostr(star));
  end
  else begin
    Memo1.Lines.Add('(x)      = ');
    Memo1.Lines.Text := Memo1.Lines.Text + '(x) - 1 = ';
  end;
  Series1.Clear;
  Series3.Clear;
  if Lambda > 3 then Lambda := 3;
  if Lambda < -2 then Lambda := -2;
  Series3.AddXY(s, Lambda);
  min :=  - 10;
  if s < min then min := s;
  max :=  5;
  if s > max then max := s;
  dx := (max - min) / n;
  Lambdab := 1;
  for i := 0 to n do begin
    s := i * dx + min;
    Lambda := Dirichlet_Lambda_Function(s);
    if Lambda > 3 then Lambda := 3;
    if (Lambdab = -2) and (Lambda = 3) then begin
      Series1.AddXY(s, Lambdab, '', clBlue);
      Series1.AddXY(s, Lambda, '', clBlue);
    end;
    if Lambda < -2 then Lambda := -2;
    if (Lambda < 3) and (Lambda > -2) then Series1.AddXY(s, Lambda, '', clBlue)
                                      // Ot̃x[X̐FƓɂČȂ܂B
                                      else Series1.AddXY(s, Lambda, '', clBtnFace);
    Lambdab := Lambda;
  end;
end;

//-------------------------------------------
// extended  Epsilon ݒ
//-------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  d, m: extended;
begin
  Memo1.Clear;
  LDBL_EPSILON := 1;
  d := 1;
  repeat
    LDBL_EPSILON := LDBL_EPSILON / 2;
    m := d + LDBL_EPSILON;
  until m = d;
  LDBL_EPSILON := LDBL_EPSILON * 2;
end;

end.
